#ifndef __INC_CGILIB_H__
#define __INC_CGILIB_H__
/*********************************************************************
  CGIp by CCC

*********************************************************************/
#define		CGILIB_VERSION				0x0101
/* #define CGI_DEBUG */						/* fobOIRgAEg */
#include <stdio.h>
#include <time.h>
#if defined(_WIN32) || defined(_WIN64)
#define cgi_mkdir(d) mkdir(d)
#define cgi_strtoll(s, p, b) _strtoi64(s, p, b)
#define cgi_strtoull(s, p, b) _strtoui64(s, p, b)
#define sleep(s) Sleep((s)*1000)
#else
#define cgi_mkdir(d) mkdir(d,0755)
#define cgi_strtoll(s, p, b) strtoll(s, p, b)
#define cgi_strtoull(s, p, b) strtoull(s, p, b)
#define sleep(s) sleep(s)
#endif

#ifdef CGI_DEBUG
#include "dbgalloc.h"
#endif

#define CGILIB_MAXPARANAME		31
#define CGILIB_MAXMIMENAME		47
#define CGILIB_MAXFILENAME		255
#define CGILIB_MAXSVFLNAME		31
#define CGILIB_MAXTDIRNAME		205
#define CGILIB_TMPFILEBASE		"_cgitmp_"

#define HEX2DEC(c) (((c)>='a'&&(c)<='f')?((c)-'a'+10):((c)>='A'&&(c)<='F')?((c)-'A'+10):((c)>='0'&&(c)<='9')?((c)-'0'):(c))
#define ISURLCHAR(c)(((c)>='0'&&(c)<='9')||((c)>='A'&&(c)<='Z')||((c)>='a'&&(c)<='z')||(c)=='.'||(c)=='-'||(c)=='*'||(c)=='_')

#ifdef NDEBUG
#define CGI_ASSERT(b,m)
#define CGI_ASSERT2(b,m)
#else
#define CGI_ASSERT(b,m) {if(!(b)){printf("%s\nsource:%s\nline:%d\n",#m,__FILE__,__LINE__);fflush(stdout);exit(3);}}
#define CGI_ASSERT2(b,m) {if(!(b)){printf("%s<br />\nsource:%s<br />\nline:%d\n",#m,__FILE__,__LINE__);exit(3);}}
#endif

/* R[h */
typedef enum{
	CGI_SJIS = 0,
	CGI_EUC,
	CGI_UTF8
} cgilib_code;

/* GR[hp^[ */
typedef enum{
	CGI_URLENCGET,
	CGI_URLENCPOST,
	CGI_MULTIPART
} cgilib_enctype;

/* NGXg\bh */
typedef enum{
	CGI_GET = 1,
	CGI_POST,
	CGI_POSTM
} cgilib_request;

/* tH[f[^ */
typedef struct _cgifd{
	cgilib_request request_type;
	char name[CGILIB_MAXPARANAME+1];
	char *value;
	char mime[CGILIB_MAXMIMENAME+1];
	char filename[CGILIB_MAXFILENAME+1];
	char svfile[CGILIB_MAXSVFLNAME+1];
	unsigned long long valuesize;
	struct _cgifd *next;
	struct _cgifd *prev;
} cgiform, *pcgiform;

extern const char* const cgi_code_string[];
extern const char* const cgi_uri_prefix[];



/*------------------------------------------------------------------
 R[h̕ύX
 cd      : gp镶R[h(CGI_SJIS,CGI_EUC,CGI_UTF8̂ꂩ)
 ߂l  : ύXO̕R[h(CGI_SJIS,CGI_EUC,CGI_UTF8̂ǂꂩ)
------------------------------------------------------------------*/
extern cgilib_code setcgicode(cgilib_code cd);

/*------------------------------------------------------------------
 R[h̎擾
 ߂l  : ݂̕R[h(CGI_SJIS,CGI_EUC,CGI_UTF(̂ǂꂩ)
------------------------------------------------------------------*/
extern cgilib_code getcgicode(void);

/*------------------------------------------------------------------
 e|t@C̃fBNgw
 tempdir : fBNgpX(Α΂ǂł:p[~bV)
 ߂l  : 0: -1:s
------------------------------------------------------------------*/
extern int settempdir(const char *tempdir);

/*------------------------------------------------------------------
 e|t@C̃fBNg擾
 tempdir : fBNgpX̊i[
 len     : fBNgpX̊i[̃TCY(\0܂)
 ߂l  : 0: -1:s
------------------------------------------------------------------*/
extern int gettempdir(char *tempdir, int len);

/*------------------------------------------------------------------
 t@CAbv[hɃobt@]ƂɌĂ΂֐o^
 handler : t@CAbv[hɃobt@]ƂɌĂ΂֐
 ߂l  : OZbgĂ֐
------------------------------------------------------------------*/
extern void(*set_upload_handler(void(*handler)
		(const pcgiform pform, const char *buf, int bufsize)))
			(const pcgiform pform, const char *buf, int bufsize);

/*------------------------------------------------------------------
 sɌĂяo֐̓o^
 handler : sɌĂяo֐
 ߂l  : OZbgĂ֐
------------------------------------------------------------------*/
extern void(*set_badalloc(void(*handler)(void)))(void);

/*------------------------------------------------------------------
 imallocɈ炩ԂĂj
 size    : 郁TCY
 flag    : s̓i0:߂lNULLԂ 1:s̊֐Ăԁj
 src     : __FILE__w
 line    : __LINE__w
 ߂l  : 蓖ĂꂽAhX
------------------------------------------------------------------*/
#ifdef CGI_DEBUG
extern void *cgi_alloc(size_t size, int flag, const char *src, int line);
#else
extern void *cgi_alloc(size_t size, int flag);
#endif

/*------------------------------------------------------------------
 wb_o̓tÕZbg
 flag    : wb_o̓tO 0:܂ 0ȊO:o͍ς
------------------------------------------------------------------*/
extern void set_headerflg(int flag);

/*------------------------------------------------------------------
 wb_o̓tO̎擾
 ߂l  : wb_o̓tO 0:܂ 0ȊO:o͍ς
------------------------------------------------------------------*/
extern int get_headerflg(void);

/*------------------------------------------------------------------
 wb_o̓tO̔ɂHTTPwb_o
 head_str: wb_ݒ肷Bj"Content-type: text/html\x0d\x0a\x\x0d\x0a"
------------------------------------------------------------------*/
extern void put_http_header(const char *head_str);

/*------------------------------------------------------------------
 wb_o̓tO̔ɂHTMLwb_o
------------------------------------------------------------------*/
extern void put_html_header(void);

/*------------------------------------------------------------------
 wb_o̓tO̔ɂTEXTwb_o
------------------------------------------------------------------*/
extern void put_text_header(void);

/*------------------------------------------------------------------
 DESÍ
 pw      : ÍΏە(8oCg܂)
 salt    : Í̃^l(2oCg܂)
 buf     : Íꂽ̊i[AhX NULLw
 buflen  : buf̒iŒ14oCgjbufNULL̏ꍇ͖(\0܂)
 ߂l  : bufւ̃|C^BbufNULLȂΓÓIւ̃|C^
------------------------------------------------------------------*/
extern char *des_crypt(const char *pw, const char *salt, char* buf, int buflen);

/*------------------------------------------------------------------
 ϐ擾iNULL̏ꍇ͋󕶎Ԃj
 envkey  : ϐ̃L[
 ߂l  : w肳ꂽL[̊ϐBȂ΋󕶎
------------------------------------------------------------------*/
extern const char *getenv_value(const char *envkey);

/*------------------------------------------------------------------
 oCg`FbN
 src     : Ώەւ̃|C^
 ߂l  : Ώە̃oCg
------------------------------------------------------------------*/
extern int char_size(const char *src);

/*------------------------------------------------------------------
 ̕ւ̃|C^Ԃ
 src     : Ώەւ̃|C^
 ߂l  : ̕ւ̃|C^
------------------------------------------------------------------*/
extern char *char_next(const char *src);

/*------------------------------------------------------------------
 O̕ւ̃|C^Ԃ
 sta     : ̐擪ւ̃|C^
 cur     : ݂̕ւ̃|C^
 ߂l  : O̕ւ̃|C^
------------------------------------------------------------------*/
extern char *char_prev(const char *sta, const char *cur);

/*------------------------------------------------------------------
 ̃Rs[ԂispɂȂKfree()ŉ邱Ɓj
 str     : Rs[̕
 ߂l  : VɊmۂꂽւ̃|C^isNULLj
------------------------------------------------------------------*/
extern char *copystring(const char *str);

/*------------------------------------------------------------------
 Aւ̃AhXԂispɂȂKfree()ŉ邱Ɓj
 str1    : ̘A
 str2    : E̘A
 ߂l  : Aꂽւ̃|C^isNULLj
------------------------------------------------------------------*/
extern char *addstring(const char *str1, const char *str2);

/*------------------------------------------------------------------
 ̔p𔼊p啶ɕύX
 str     : 啶ɕϊ镶iύXΏہjNULLwOK
 ߂l  : ƓAhX
------------------------------------------------------------------*/
extern char *upper_string(char *str);

/*------------------------------------------------------------------
 ̔p啶𔼊pɕύX
 str     : ɕϊ镶iύXΏہjNULLwOK
 ߂l  : ƓAhX
------------------------------------------------------------------*/
extern char *lower_string(char *str);

/*------------------------------------------------------------------
 rip̑啶EʂȂj
 str1    : rΏ1
 str2    : rΏ2
 ߂l  : :str1<str2 0: :str1>str2
------------------------------------------------------------------*/
extern int str_icomp(const char *str1, const char *str2);

/*------------------------------------------------------------------
 rip̑啶EʂȂj
 str1    : rΏ1
 str2    : rΏ2
 len     : roCg
 ߂l  : :str1<str2 0: :str1>str2
------------------------------------------------------------------*/
extern int str_icompn(const char *str1, const char *str2, size_t len);

/*------------------------------------------------------------------
 JEgioCgł͂ȂAPʁj
 str     : 𐔂镶
 ߂l  : ۂ̐̕
------------------------------------------------------------------*/
extern size_t str_count(const char *str);

/*------------------------------------------------------------------
 񌟍ip̑啶EʂȂj
 src     : Ώە
 search  : 镶
 ߂l  : qbgւ̃AhXBȂNULLB
------------------------------------------------------------------*/
extern char *str_isearch(const char *src, const char *search);

/*------------------------------------------------------------------
 񕪊
 base    : ƂȂ镶
 sep     : ؂蕶iJ}^uȂǁj
 quot    : pi_uNH[e[VȂǁBȂ0wj
 col     : 鐔i0w肷Ƌ؂蕶Sĕj
 cols    : 敪zi**p&pœnjsvɂȂsplit_freeŉ
 ߂l  : ꂽicols̔z񐔁j
------------------------------------------------------------------*/
extern int str_split(const char *base, const char *sep, char quot, int col, char ***cols);

/*------------------------------------------------------------------
 ̊eڂւ̃|C^z
 cols    : ꂽeڂւ̃|C^z̐擪AhX
 colsize : istr_split̖߂lƓlj
------------------------------------------------------------------*/
extern void split_free(char **cols, int colsize);

/*------------------------------------------------------------------
 u
 str     : ΏۂƂȂ镶
 before  : u镶
 after   : u̕
 count   : ϊi0̏ꍇ͑Sāj
 ߂l  : uꂽBisvɂȂfreeŉj
------------------------------------------------------------------*/
extern char *str_rep(const char *str, const char *before, const char *after, int count);

/*------------------------------------------------------------------
 uip̑啶ʂȂj
 str     : ΏۂƂȂ镶
 before  : u镶
 after   : u̕
 count   : ϊi0̏ꍇ͑Sāj
 ߂l  : uꂽBisvɂȂfreeŉj
------------------------------------------------------------------*/
extern char *str_irep(const char *str, const char *before, const char *after, int count);

/*------------------------------------------------------------------
 ؂oiPʁj
 str     : ΏۂƂȂ镶
 start   : Jnʒui0當PʂŃJEgj
 count   : ؂oi0ȂΎcSāj
 ߂l  : ؂oBsNULLisvɂȂfreeŉ邱Ɓj
------------------------------------------------------------------*/
extern char *substring(const char *str, size_t start, size_t count);

/*------------------------------------------------------------------
 ؂oioCgPʁj
 str     : ΏۂƂȂ镶
 start   : Jnʒui0oCgPʂŃJEgj
 count   : ؂ooCgi0ȂΎcSāj
 ߂l  : ؂oBsNULLisvɂȂfreeŉ邱Ɓj
------------------------------------------------------------------*/
extern char *bsubstring(const char *str, size_t start, size_t count);

/*------------------------------------------------------------------
 URLGR[h
 str     : URLGR[h镶B
 ߂l  : GR[hꂽBsNULLisvɂȂfreeŉj
------------------------------------------------------------------*/
extern char *urlenc(const char *str);

/*------------------------------------------------------------------
 URLfR[h
 str     : URLfR[h镶BiXV܂j
 ߂l  : fR[hꂽBiƓj
------------------------------------------------------------------*/
extern char *urldec(char *str);

/*------------------------------------------------------------------
 GETŎ󂯎f[^̃m[hXg̐擪AhXԂ
 ߂l  : 擪m[h̃AhX
------------------------------------------------------------------*/
extern const pcgiform getfirstnode_get(void);

/*------------------------------------------------------------------
 POSTŎ󂯎f[^̃m[hXg̐擪AhXԂ
 ߂l  : 擪m[h̃AhX
------------------------------------------------------------------*/
extern const pcgiform getfirstnode_post(void);

/*------------------------------------------------------------------
 L[ɂm[ȟ
 key     : L[i啶Ə͋ʂj
 pstart  : tH[JnʒuBNULLȂΐ擪GET->POST̏
 ߂l  : qbgm[h̃AhXBȂNULL
------------------------------------------------------------------*/
extern const pcgiform search_form(const char *key, const pcgiform pstart);

/*------------------------------------------------------------------
 L[ɂľ
 key     : L[i啶Ə͋ʂj
 ߂l  : qbgL[̒lBȂ΋󕶎B
------------------------------------------------------------------*/
extern const char *request(const char *key);

/*------------------------------------------------------------------
 L[ɂľi݈ʒuj
 key     : L[i啶Ə͋ʂj
 ߂l  : qbgL[̒lBȂ΋󕶎B
------------------------------------------------------------------*/
extern const char *next_request(const char *key);

/*------------------------------------------------------------------
 tH[f[^Ǎ
 maxsize : fR[hO̍őǍTCYioCgj
 enctype : GR[h^CviCGI_URLENCGET/CGI_URLENCPOST/CGI_MULTIPARTj
------------------------------------------------------------------*/
extern void getformdata(unsigned long long maxsize, cgilib_enctype enctype);

/*------------------------------------------------------------------
 URLɃAJ[^O
 str     : AJ[t^Ώۂ̕
 ߂l  : AJ[t^ꂽAhXBsNULL,gpfree()
------------------------------------------------------------------*/
extern char *autolink(const char *str);

/*------------------------------------------------------------------
 base64GR[hs
 data    : GR[hΏۂ̃obt@擪AhX
 len     : obt@̃TCY
 ߂l  : GR[hꂽBsNULL,gpfree()ŉB
------------------------------------------------------------------*/
extern char *base64encode(const char *data, size_t len);

/*------------------------------------------------------------------
 base64fR[hs
 b64str  : base64GR[hꂽ
 data    : fR[h̃obt@ւ̃AhXAhXgpfree
 ߂l  : fR[h̃f[^TCY
------------------------------------------------------------------*/
extern size_t base64decode(const char *b64str, char **data);

/*------------------------------------------------------------------
 NbL[Zbg
 key     : NbL[̃L[
 value   : keyɑ΂liNbL[ɐݒ肷j
 period  : NbL[̕ۑԁi0ŃuEU܂36001ԁj
 ߂l  : 0ŐA0ȊOŎs
------------------------------------------------------------------*/
extern int set_cookie(const char *key, const char *value, time_t period);

/*------------------------------------------------------------------
 NbL[폜
 key     : NbL[̃L[
 ߂l  : 0ŐA0ȊOŎs
------------------------------------------------------------------*/
extern int delete_cookie(const char *key);

/*------------------------------------------------------------------
 NbL[擾
 key     : NbL[̃L[
 value   : NbL[擾obt@̃AhX
 bufsize : valuȇ傫ŏI['\0'
 ߂l  : Rs[ꂽoCgBvalueNULLbufsize0ȂKvTCY
------------------------------------------------------------------*/
extern size_t get_cookie(const char *key, char *value, size_t bufsize);

/*------------------------------------------------------------------
 JPEGC[W̏c̃TCY擾
 jpeg    : ɓǂݍJPEGC[W
 size    : jpegC[W̃TCY
 witth   : ̃TCYi[ϐAhX
 height  : c̃TCYi[ϐAhX
 ߂l  : 0As0ȊO
------------------------------------------------------------------*/
extern int get_jpeg_size(const unsigned char *jpeg, size_t size, unsigned *width, unsigned *height);

/*------------------------------------------------------------------
 GIFC[W̏c̃TCY擾
 gif     : ɓǂݍGIFC[W
 size    : gifC[W̃TCY
 witth   : ̃TCYi[ϐAhX
 height  : c̃TCYi[ϐAhX
 ߂l  : 0As0ȊO
------------------------------------------------------------------*/
extern int get_gif_size(const unsigned char *gif, size_t size, unsigned *width, unsigned *height);

/*------------------------------------------------------------------
 PNGC[W̏c̃TCY擾
 png     : ɓǂݍPNGC[W
 size    : pngC[W̃TCY
 witth   : ̃TCYi[ϐAhX
 height  : c̃TCYi[ϐAhX
 ߂l  : 0As0ȊO
------------------------------------------------------------------*/
extern int get_png_size(const unsigned char *png, size_t size, unsigned *width, unsigned *height);

/*------------------------------------------------------------------
 t@Cɓǂݍ
 file    : ǂݍރt@C
 buf     : ǂݍ񂾃f[^i[AhXBsNULLBgpςfree
 ߂l  : ǂݍ܂ꂽt@CTCYis0j
------------------------------------------------------------------*/
extern size_t fileread(const char *file, char **buf);

/*------------------------------------------------------------------
 WindowsŃ\PbggpOɕKĂяoBLinuxnł͉Ȃ
 ߂l  : 0ŐB0ȊO͎s
------------------------------------------------------------------*/
extern int cgi_sock_init(void);

/*------------------------------------------------------------------
 WindowsŃ\PbggpȂȂĂяoBLinuxnł͉Ȃ
 ߂l  : 0ŐB-1͎s
------------------------------------------------------------------*/
extern int cgi_sock_end(void);

/*------------------------------------------------------------------
 IPv4̃AhXmF
 ipstr   : 镶
 ߂l  : 0ԂIPAhXł͂ȂB0ȊOԂIPAhX
------------------------------------------------------------------*/
extern int is_ipv4addr(const char *addr);

/*------------------------------------------------------------------
 IPv4AhX1INebgƂɊi[
 ipv4str : IPv4
 ipv4oct : unsigned char [4]̐擪AhX
 ߂l  : 0ԂƐB0ȊOԂƎs
------------------------------------------------------------------*/
extern int ipv4_parse(const char *ipv4str, unsigned char ipv4oct[4]);

/*------------------------------------------------------------------
 zXgIPv4AhX擾
 host    : zXg
 ipv4    : IPv4\L̕i[obt@
 len     : IPv4\L̕i[obt@̃TCY
 ߂l  : 0ԂƐBԂƃobt@̈sAԂƃG[
------------------------------------------------------------------*/
extern int host2ipv4addr(const char *host, char *ipv4, size_t len);

/*------------------------------------------------------------------
 IPv4AhXzXg擾
 ipv4    : IPv4AhX̕\L
 host    : zXgi[obt@
 len     : zXgi[obt@̃TCY
 ߂l  : 0ԂƐBԂƃobt@̈sAԂƃG[
------------------------------------------------------------------*/
extern int ipv4addr2host(const char *ipv4, char *host, size_t len);

/*------------------------------------------------------------------
 t@C̃Rs[
 destfile: Rs[̃t@C
 srcfile : Rs[̃t@C
 ߂l  : 0ԂƐBԂƌ̓ǎAԂƐ̏G[
------------------------------------------------------------------*/
extern int filecpy(const char *destfile, char *srcfile);

/*------------------------------------------------------------------
 G[o͂ďI
 msg     : bZ[WtH[}bg
 ...     : printfƓgB
------------------------------------------------------------------*/
extern void cgi_errend(const char *msg, ...);

/*------------------------------------------------------------------
 G[o͂ďI
 line    : __LINE__wB\[XƍsoȂȂ0
 file    : __FILE__wBline0łȂΗL
 msg     : bZ[WtH[}bg
 ...     : printfƓgB
------------------------------------------------------------------*/
extern void cgi_errendex(int line, const char *file, const char *msg, ...);


/* ֐Ăяoȗp}N(ɕςmł) */
#ifdef CGI_DEBUG
#define cgialloc(s) cgi_alloc(s,1,__FILE__,__LINE__)
#else
#define cgialloc(s) cgi_alloc(s,1)
#endif
#endif /* __INC_CGILIB_H__ */
