/*********************************************************
 Abv[_[ by CCC
*********************************************************/
#include "cgilib.h"
#include "upld.h"
#include "md5.h"
#include <string.h>
#include <ctype.h>
#if defined(_WIN32) || defined(_WIN64)
#include <windows.h>
#include <io.h>
#include <fcntl.h>
#endif

static int param;
static unsigned long g_id;
static int method;
static const char *remote_user;
static char lock_dir[512];
static char list_file[512];
static char list_tmp[512];

static md5_context md5_ctx;

static void s_upload_handler(const pcgiform pform, const char* buf, int buflen);

int main(void)
{
	FILE *pfc;
	/* settempdir("../../upld/tmp"); */
	set_upload_handler(s_upload_handler);
	settempdir(UPLD_TMPDIR);
	if(str_icomp(getenv_value("REQUEST_METHOD"),"GET")){
		getformdata(UPLD_MAXSENDSIZE, CGI_MULTIPART);
		method = 1;
	}else{
		getformdata(UPLD_MAXSENDSIZE, CGI_URLENCGET);
		method = 0;
	}
	remote_user = getenv_value("REMOTE_USER");
	sprintf(lock_dir, UPLD_LOCKDIR, remote_user);
	sprintf(list_file, UPLD_LISTFILE, remote_user);
	sprintf(list_tmp, UPLD_LISTTEMP, remote_user);
	if((pfc=fopen(list_file,UPLD_F_APPEND)) != NULL) fclose(pfc);
	param = atoi(request("param"));
	g_id = strtoul(request("id"),NULL,10);
	switch(param){
		case UPLD_PARA_UPLOAD:
			upload_file();
			printf("Location: %s\x0d\x0a\x0d\x0a", UPLD_CGINAME);
		break;
		case UPLD_PARA_DOWNLOAD:
			download_file();
		break;
		case UPLD_PARA_PREVIEW:
			preview_file();
		break;
		case UPLD_PARA_DELETE:
			delete_file();
			printf("Location: %s\x0d\x0a\x0d\x0a", UPLD_CGINAME);
		break;
		default:
			base_screen();
		break;
	}
	return 0;
}

/* { */
void base_screen(void)
{
	FILE *pf;
	filelist fl;
	const char *splcolor;
	int clflg, cnt=1, i;
	char datestr[64];
	char mime[128];
	struct tm *ptm;
	unsigned long fc;
	
	fc = get_listcount();
	pf = fopen(list_file,UPLD_F_READ);
	if(pf==NULL) cgi_errend("t@CJ܂B");
	put_html_header();
	printf(
		"<html>\n"
		"<head>\n"
		"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">\n"
		"<script language=\"javascript\" src=\"chk.js\"></script>\n"
		"</head>\n"
		"<title>%s</title>\n"
		"<style type=\"text/css\">\n"
		"h1{font-size: 14pt; color: #000000;}\n"
		"h2,ul,dt{font-size: 12pt;color:#00000;}\n"
		"h3{font-size: 12pt; color: #000000;}\n"
		"div{font-size: 10pt;  color: #000000;}\n"
		"table,tbody,tr{font-size: 10pt; color: #000000; border-color: #3080ff; background-color: #c0e0ff; border-width: 0px 1px 1px 0px; border-style: solid;}\n"
		"td{font-size: 10pt;color: #555555; border-color: #3080ff; border-width: 1px 0px 0px 1px; border-style: solid;}\n"
		"hr{border: 0; border-bottom: 1px dashed #c0ccff; background: #3080ff;}\n"
		"body{font-size: 9pt; color:#000000; background-color: #f0f0f0f; }\n"
		"a{text-decoration: none;}\n"
		"a:visited{color: #0000ff;}\n"
		"a:link{color: #0000ff;}\n"
		"a:hover{color: #ff0000;}\n"
		"</style>\n"
		"<body>\n"
		"<div>\n"
		"<h1><a href=\"%s\">%s</a></h1>\n"
		"<b>%s</b><br>\n"
		"<hr>\n"
		"<div id=\"msg1\">t@C̃TCY͍ő<b>%llu%s</b>x܂<img src=\"./wait.gif\" width=\"0\" height=\"0\"></div>\n",
		UPLD_TITLE,
		UPLD_CGINAME, UPLD_TITLE,
		*remote_user ? remote_user : "<font color=\"#ff0000\">shared file list</font>",
		UPLD_SIZE2(UPLD_MAXSENDSIZE-4096), UPLD_SIZEU2(UPLD_MAXSENDSIZE-4096)
	);
	printf(
		"<form name=\"upl\" action=\"%s\" method=\"POST\" enctype=\"multipart/form-data\" onsubmit=\"return UplCheck();\">\n"
		"Abv[ht@CF<input type=\"file\" name=\"upfile\" size=\"50\">\n"
		"<input type=\"hidden\" name=\"param\" value=\"%d\">\n"
		"<input type=\"submit\" name=\"up\" value=\"Abv[h\"></form>\n"
		"<hr><br><br>\n",
		UPLD_CGINAME,
		UPLD_PARA_UPLOAD
	);
	printf("t@C : <b>%lu/%lu</b><br>\n", fc, UPLD_MAXDATACNT);
	if(fc >= UPLD_MAXDATACNT){
		printf(
			"<font color=\"#ff0000\">t@C̏<b>%lu</b>̂ߎ̃Abv[h<br>"
			"ԌÂt@C폜܂B</font>",
			UPLD_MAXDATACNT
		);
	}
	printf(
		"<form name=\"del\" action=\"%s\" method=\"POST\" enctype=\"multipart/form-data\" onsubmit=\"return DelCheck();\">\n",
		UPLD_CGINAME
	);
	
	printf(
		"<table cellspacing=\"0\" cellpadding=\"3\"><tbody>\n"
		"<tr>"
		"<td align=\"center\"><font color=\"#3080ff\"><b>No</b></font></td>"
		"<td align=\"center\"><font color=\"#3080ff\"><b>폜</b></font></td>"
		"<td align=\"center\"><font color=\"#3080ff\"><b>t@C</b></font></td>"
		"<td align=\"center\"><font color=\"#3080ff\"><b>TCY</b></font></td>"
		"<td align=\"center\"><font color=\"#3080ff\"><b>t</b></font></td>"
		"<td align=\"center\"><font color=\"#3080ff\"><b>MIME</b></font></td>"
		"<td align=\"center\"><font color=\"#3080ff\"><b>MD5</b></font></td></tr>"
		"</tr>\n"
	);
	
	
	clflg = 0;
	while(fread(&fl,sizeof(fl),1,pf)==1){
		for(i=0; i<sizeof(mime)-1; ++i){
			if(!fl.mime[i] || fl.mime[i]=='/') break;
			mime[i] = tolower(fl.mime[i]);
		}
		mime[i] = '\0';
		clflg = !clflg;
		if(clflg) splcolor = "#ffffff";
		else splcolor = "#e0fff0";
		ptm = localtime((time_t*)&fl.id);
		sprintf(datestr,"%04d/%02d/%02d %02d:%02d:%02d",
				ptm->tm_year+1900, ptm->tm_mon+1, ptm->tm_mday,
				ptm->tm_hour, ptm->tm_min, ptm->tm_sec);
		printf(
			"<tr>"
			"<td align=\"right\" nowrap bgcolor=\"%s\">%d</d>"
			"<td nowrap bgcolor=\"%s\"><input type=\"checkbox\" name=\"delkey\" value=\"%lu\"></td>"
			"<td nowrap bgcolor=\"%s\"><a href=\"%s?param=%d&id=%lu\" target=\"_blank\"></a> / <a href=\"%s?param=%d&id=%lu\">%s</a></td>"
			"<td align=\"right\" nowrap bgcolor=\"%s\">%s</td>"
			"<td align=\"center\" nowrap bgcolor=\"%s\">%s</td>"
			"<td nowrap bgcolor=\"%s\">%s</td>"
			"<td nowrap bgcolor=\"%s\">%s</td>"
			"</tr>\n",
			splcolor, cnt++,
			splcolor, fl.id,
			splcolor, UPLD_CGINAME, strncmp(mime,"image",5) ? UPLD_PARA_DOWNLOAD : UPLD_PARA_PREVIEW, fl.id, UPLD_CGINAME, UPLD_PARA_DOWNLOAD, fl.id,fl.filename,
			splcolor, screen_size(fl.size),
			splcolor, datestr,
			splcolor, fl.mime,
			splcolor, fl.filehash
		);
	}
	if(ferror(pf)) cgi_errend("̓t@CŃG[");
	fclose(pf);
	printf(
		"</tbody></table><br><br>\n"
		"<hr>\n"
		"<input type=\"hidden\" name=\"param\" value=\"%d\">\n"
		"<input type=\"submit\" name=\"dlt\" value=\"폜\">"
		"</form>\n"
		"<hr>\n",
		UPLD_PARA_DELETE
	);
	printf(
		"</div>\n"
		"</body>\n</html>\n"
	);
}

/* t@CTCY\ */
char *screen_size(unsigned long size)
{
	static char sizestr[32];
	char buf[24], *p;
	
	if(size < (1<<10)){
		sprintf(sizestr, "<b>%lu B</b>", size);
	}else{
		sprintf(buf, "%.2f", UPLD_SIZE(size));
		if((p=strchr(buf,'.'))!=NULL){
			if(!strncmp(p+1,"00",2)) *p = '\0';
		}
		sprintf(sizestr, "<b>%s %s</b>", buf, UPLD_SIZEU(size));
	}
	return sizestr;
}

/* t@CJEg */
unsigned long get_listcount(void)
{
	long po;
	FILE *pf;
	if((pf=fopen(list_file,UPLD_F_READ)) == NULL) cgi_errend("Xgt@CJ܂");
	if(fseek(pf,0,SEEK_END)) cgi_errend("fseekG[");
	if((po=ftell(pf)) < 0) cgi_errend("t@CTCY擾G[");
	fclose(pf);
	return ((unsigned long)po/sizeof(filelist));
}

/* Abv[h */
void upload_file(void)
{
	FILE *ptemp, *pfile;
	pcgiform pform;
	char tmpfile[512], upfile[512], *p, buf[32], delfile[512];
	unsigned char digest[16];
	unsigned long fileid;
	int i;
	filelist fl;
	
	if(method == 0) cgi_errend("GETł̓t@C͂ł܂񂪁B");
	pform = search_form("upfile",NULL);
	if(pform == NULL) cgi_errend("p[^G[");
	if(!pform->valuesize) cgi_errend("t@CTCY[łB");
	if(!pform->svfile[0]) cgi_errend("t@Cł͂܂B");
	gettempdir(tmpfile,200);
	strcat(tmpfile,"/");
	strcat(tmpfile,pform->svfile);
	lock_file();
	fileid = time(NULL);
	while(id_check(fileid)){
		sleep(1);
		fileid = time(NULL);
	}
	sprintf(upfile, "%s/%s_%lu", UPLD_UPDIR, remote_user, fileid);
	if((ptemp=fopen(list_tmp,UPLD_F_WRITE)) == NULL){
		unlock_file();
		remove(tmpfile);
		cgi_errend("t@CXg̃I[vɎsi݂ł܂j");
	}
	if((pfile=fopen(list_file,UPLD_F_READ)) == NULL){
		unlock_file();
		remove(tmpfile);
		cgi_errend("t@CXg̃I[vɎsi݂ł܂j");
	}
	memset(&fl, 0, sizeof(fl));
	fl.id = fileid;
	for(p=pform->filename+strlen(pform->filename)-1;p!=pform->filename;p=char_prev(pform->filename,p)){
		if(*p == '\\' || *p == '/' || *p == ':'){
			++p;
			break;
		}
	}
	strncpy(fl.filename, p, sizeof(fl.filename));
	fl.filename[sizeof(fl.filename)-1] = '\0';
	strncpy(fl.mime, pform->mime, sizeof(fl.mime));
	fl.mime[sizeof(fl.mime)-1] = '\0';
	fl.size = pform->valuesize;
	md5_finish(&md5_ctx, digest);
	for(i=0; i<16; ++i) sprintf(fl.filehash+i*2, "%02x", digest[i]);
	fwrite(&fl,sizeof(fl),1,ptemp);
	i = 1;
	while(fread(&fl,sizeof(fl),1,pfile)==1){
		++i;
		if(ferror(ptemp)){
			unlock_file();
			remove(tmpfile);
			cgi_errend("ݎs");
		}
		if(i <= UPLD_MAXDATACNT){
			fwrite(&fl,sizeof(fl),1,ptemp);
		}else{
			sprintf(delfile, "%s/%s_%lu", UPLD_UPDIR, remote_user, fl.id);
			remove(delfile);
		}
	}
	if(ferror(pfile)){
		unlock_file();
		remove(tmpfile);
		cgi_errend("Ǎݎs");
	}
	fclose(pfile);
	fclose(ptemp);
	if(remove(list_file)){
		unlock_file();
		remove(tmpfile);
		cgi_errend("XgXVł܂B");
	}
	if(rename(list_tmp,list_file)){
		unlock_file();
		remove(tmpfile);
		cgi_errend("Xgt@C폜܂B");
	}
	if(rename(tmpfile,upfile)){
		unlock_file();
		remove(tmpfile);
		cgi_errend("Abv[ht@C̃Rs[s");
	}
	unlock_file();
}

/* t@CbN */
void lock_file(void)
{
	int i;
	for(i=0;i<10;++i){
		if(cgi_mkdir(lock_dir)) sleep(1);
		else break;
	}
	/* 10bȏ҂͂ */
}

/* t@CAbN */
void unlock_file(void)
{
	rmdir(lock_dir);
}

/* id check */
int id_check(unsigned long id)
{
	FILE *pf;
	filelist fl;
	int ret = 0;
	if((pf=fopen(list_file,UPLD_F_READ)) == NULL){
		cgi_errend("Xgt@CJ܂B");
		unlock_file();
	}
	while(fread(&fl,sizeof(fl),1,pf)==1){
		if(fl.id == id){
			ret = 1;
			break;
		}
	}
	fclose(pf);
	return ret;
}

/* _E[h */
void download_file(void)
{
	FILE *pf;
	char downfile[256];
	char buf[4096];
	filelist fl;
	size_t bufsize;
	
	if(get_file_list(&fl,g_id)) cgi_errend("t@C܂B");
	sprintf(downfile, "%s/%s_%lu", UPLD_UPDIR, remote_user, g_id);
#if defined(_WIN32) || defined(_WIN64)
	/* win͕Wo͂oCi */
	if(setmode(fileno(stdout),O_BINARY) == -1) cgi_errendex(__LINE__, __FILE__, "setmode error!");
#endif
	
	if((pf=fopen(downfile,UPLD_F_READ)) == NULL) cgi_errend("t@CJ܂");
	printf("Content-Type: %s\x0d\x0a"
			"Content-Disposition: attachment; filename=\"%s\"\x0d\x0a"
			"Content-Length: %lu\x0d\x0a\x0d\x0a",
			fl.mime,
			fl.filename,
			fl.size);
	set_headerflg(1);
	while((bufsize=fread(buf,1,sizeof(buf),pf)) > 0){
		fwrite(buf, bufsize, 1, stdout);
		if(ferror(pf) || ferror(stdout)) cgi_errend("_E[hG[");
	}
	fclose(pf);
}

/* vr[ */
void preview_file(void)
{
	FILE *pf;
	char downfile[256];
	char buf[4096];
	filelist fl;
	size_t bufsize;
	
	if(get_file_list(&fl,g_id)) cgi_errend("t@C܂B");
	sprintf(downfile, "%s/%s_%lu", UPLD_UPDIR, remote_user, g_id);
#if defined(_WIN32) || defined(_WIN64)
	/* win͕Wo͂oCi */
	if(setmode(fileno(stdout),O_BINARY) == -1) cgi_errendex(__LINE__, __FILE__, "setmode error!");
#endif
	
	if((pf=fopen(downfile,UPLD_F_READ)) == NULL) cgi_errend("t@CJ܂");
	printf("Content-Type: %s\x0d\x0a"
			"Content-Length: %lu\x0d\x0a\x0d\x0a",
			fl.mime,
			fl.size);
	set_headerflg(1);
	while((bufsize=fread(buf,1,sizeof(buf),pf)) > 0){
		fwrite(buf, bufsize, 1, stdout);
		if(ferror(pf) || ferror(stdout)) cgi_errend("_E[hG[");
	}
	fclose(pf);
}

/* 폜 */
void delete_file(void)
{
	FILE *pfile, *ptemp;
	filelist fl;
	char delfile[256];
	pcgiform pform;
	int delflg;
	
	lock_file();
	if((pfile=fopen(list_file,UPLD_F_READ)) == NULL){
		unlock_file();
		cgi_errend("Xgt@CI[vG[");
	}
	if((ptemp=fopen(list_tmp,UPLD_F_WRITE)) == NULL){
		unlock_file();
		cgi_errend("tmpfileI[vG[");
	}
	
	while(fread(&fl,sizeof(fl),1,pfile)==1){
		if(ferror(pfile) || ferror(ptemp)){
			unlock_file();
			cgi_errend("t@CI/OG[");
		}
		for(delflg=0,pform=search_form("delkey",NULL);pform!=NULL;pform=search_form("delkey",pform)){
			if(strtoul(pform->value==NULL?"":pform->value,NULL,10)==fl.id){
				delflg = 1;
				break;
			}
		}
		if(delflg){
			sprintf(delfile, "%s/%s_%lu", UPLD_UPDIR, remote_user, fl.id);
			remove(delfile);
			continue;
		}
		fwrite(&fl, sizeof(fl), 1, ptemp);
	}
	
	fclose(pfile);
	fclose(ptemp);
	if(remove(list_file)){
		unlock_file();
		cgi_errend("XgXVł܂B");
	}
	if(rename(list_tmp,list_file)){
		unlock_file();
		cgi_errend("Xgt@C폜܂B");
	}
	unlock_file();
}

/* Xgf[^擾 */
int get_file_list(filelist *pfl, unsigned long id)
{
	FILE *pf;
	int hit = 0;
	if((pf=fopen(list_file,UPLD_F_READ)) == NULL) cgi_errend("Xgt@CI[vG[");
	while(fread(pfl,sizeof(filelist),1,pf)==1){
		if(ferror(pf)) cgi_errend("File I/O error!");
		if(pfl->id == id){
			hit = 1;
			break;
		}
	}
	fclose(pf);
	if(!hit) memset(pfl,0,sizeof(filelist));
	return (!hit);
}

static void s_upload_handler(const pcgiform pform, const char* buf, int buflen)
{
	if(!strcmp(pform->name,"upfile")){
		if(!pform->valuesize) md5_starts(&md5_ctx);
		md5_update(&md5_ctx, buf, buflen);
	}
}
